/*
 * Code related function
 *
 * $Id: code.c 1.6 Fri, 09 Oct 1998 17:21:36 +0200 crad $
 */
#include "s.h"
#include "heap.h"


void scm_code_mark(SOBJ obj)
{
  SOBJ *code, *limit;

  code = SCM_CODE_CODE(obj);
  limit = code + SCM_CODE_SIZE(obj);
  while(code < limit) {
	if (scm_is_pointer_to_heap(*code)) {
	  scm_gc_mark(*code);
	}
	code++;
  }
}

void scm_code_sweep(SOBJ obj)
{
  SOBJ *code;

#ifdef DEBUG
  scm_puts("; removing code #");  port_putx(SCM_OUTP, obj);
  scm_puts("\n");
#endif

  if ((code = SCM_CODE_CODE(obj)) != NULL) {
	scm_free(code);
	SCM_CODE_CODE(obj) = NULL;
  }
}

void scm_code_print(SOBJ obj, PORT *p)
{
  if (SCM_CODE_CODE(obj) == NULL) {
	port_puts(p, "<#code null>");
  } else {
	port_puts(p, "<#code ");
	port_putx(p, SCM_CODE_CODE(obj));
	port_puts(p, ">");
  }
}

/*-- primitives */
SOBJ scm_mkcode(SOBJ *ptr, long size)
{
  SOBJ new = scm_newcell(SOBJ_T_CODE);
  SCM_CODE_SIZE(new) = size;
  SCM_CODE_CODE(new) = scm_must_alloc(size * sizeof(SOBJ));
  memcpy(SCM_CODE_CODE(new), ptr, size * sizeof(SOBJ));
  return(new);
}

/*-- pop code from the stack and put it in a new code object */
SOBJ scm_mkcode_from_stack()
{
  return(scm_mkcode(scm_sp, scm_stack_limit - scm_sp));
}
