/*
 * Implementation of pointer type
 */
#include "s.h"

void scm_pointer_mark(SOBJ obj)
{
}

void scm_pointer_sweep(SOBJ obj)
{
  if (SCM_POINTER_ATTRIB(obj) & SCM_POINTER_ALLOCED) 
	scm_free(SCM_POINTER(obj));
  SCM_POINTER(obj) = NULL;
}

void scm_pointer_print(SOBJ obj, PORT *p)
{
  port_puts(p, "<#pointer ");
  port_putx(p, obj);
  port_putc(p, '>');
}

SOBJ scm_mkpointer()
{
  SOBJ new = scm_newcell(SOBJ_T_POINTER);
  return(new);
}

SOBJ scm_pointerp(SOBJ ptr)
{
  return(SCM_POINTERP(ptr) ? scm_true : scm_false);
}

SOBJ scm_null_pointerp(SOBJ ptr)
{
  if (SCM_POINTERP(ptr) && SCM_POINTER(ptr) == NULL)
	return(scm_true);
  return(scm_false);
}

void scm_init_pointer()
{
  scm_add_cprim("pointer?",			scm_pointerp, 		1);
  scm_add_cprim("null-pointer?",	scm_null_pointerp, 	1);
}
